#pragma once

#include <functional>

namespace Hal {

class Motor
{
public:
    virtual ~Motor() = default;

    virtual void Home() = 0;
    virtual bool IsHoming() = 0;
    virtual void Move(double pos) = 0;
    virtual bool IsMoving() = 0;
    virtual void Stop() = 0;

    virtual void HomingChanged(std::function<void()> event) = 0;
    virtual void MovingChanged(std::function<void()> event) = 0;
};

}
