#pragma once

#include "MotorGlueComponentSkel.hh"
#include "Motor.h"

#include <dzn/pump.hh>

struct MotorGlueComponent : skel::MotorGlueComponent
{
    explicit MotorGlueComponent(const dzn::locator& locator);

    Result api_Initialize(std::string id) override;
    void api_Terminate() override;
    Result api_Home() override;
    Result api_IsHoming() override;
    Result api_Move(double pos) override;
    Result api_IsMoving() override;
    Result api_Stop() override;

    void LogException(const std::exception& ex);

    const dzn::locator& m_locator;
    dzn::pump& m_pump;
    Hal::Motor* m_motor;
};
